com.saxonica.functions.xpath3

## Class UnparsedTextLines

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.FunctionCall
    - - net.sf.saxon.functions.SystemFunctionCall
      - - net.sf.saxon.functions.UnparsedText
        - - com.saxonica.functions.xpath3.UnparsedTextLines

- All Implemented Interfaces:
    Serializable, SourceLocator, LocationProvider, SaxonLocator, Callable, InstructionInfo, Locator

      public class UnparsedTextLines
      extends UnparsedText
      implements Callable

  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.functions.SystemFunctionCall

      `operation`

    - ### Fields inherited from class net.sf.saxon.expr.FunctionCall

      `argument`

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, INHERITED_CONTEXT, INSPECTION_CONTEXT, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, NAVIGATION_CONTEXT, NODE_VALUE_CONTEXT, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, W3C_CONSUMING, W3C_FREE_RANGING, W3C_GROUP_CONSUMING, W3C_MOTIONLESS, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `UnparsedTextLines()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Sequence` | `call(XPathContext context, Sequence[] arguments)` Evaluate the expression
    `Item` | `evaluateItem(XPathContext context)` This method handles evaluation of the function: it returns a StringValue in the case of unparsed-text(), or a BooleanValue in the case of unparsed-text-available().
    `static URI` | `getAbsoluteURI(String href, String baseURI)`
    `static XPathException` | `handleIOError(URI absoluteURI, IOException ioErr)`
    `SequenceIterator` | `iterate(XPathContext context)` Return an Iterator to iterate over the values of a sequence.
    `static void` | `main(String[] args)`
    `static CharSequence` | `readFile(NameChecker checker, Reader reader)` Read the contents of an unparsed text file
    `CharSequence` | `readFile(String href, String baseURI, String encoding, XPathContext context)` Supporting routine to load one external file given a URI (href) and a baseURI

    - ### Methods inherited from class net.sf.saxon.functions.UnparsedText

      `checkArguments, computeSpecialProperties, evalUnparsedText, getAbsoluteURI, getExpressionBaseURI, handleIOError, preEvaluate, readFile`

    - ### Methods inherited from class net.sf.saxon.functions.SystemFunctionCall

      `addContextDocumentArgument, addDocToPathMap, bindStaticContext, computeCardinality, copy, equalOrNull, equals, getContextNode, getConvertingCallable, getDefaultArgumentNode, getDetails, getErrorCodeForTypeErrors, getFunctionItemType, getImplementationMethod, getItemType, getOperation, getRequiredType, iterateSubExpressionInfo, makeSystemFunction, optimize, setDetails, useContextItemAsDefault`

    - ### Methods inherited from class net.sf.saxon.expr.FunctionCall

      `addExternalFunctionCallToPathMap, checkArgumentCount, explain, getArguments, getDisplayName, getExpressionName, getFunctionName, getNumberOfArguments, hashCode, iterateSubExpressions, promote, replaceSubExpression, setArguments, setFunctionName, simplify, simplifyArguments, toString, typeCheck`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getExpressionCompiler, getHostLanguage, getIntegerBounds, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getStreamability, getStreamingAdjunct, getSystemId, getSystemId, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateEvents, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, toPattern, toStreamingPattern, typeError`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### UnparsedTextLines

          public UnparsedTextLines()

  - ### Method Detail

    - #### evaluateItem

          public Item evaluateItem(XPathContext context)
                            throws XPathException

      This method handles evaluation of the function: it returns a StringValue in the case of unparsed-text(), or a BooleanValue in the case of unparsed-text-available(). In the case of unparsed-text-lines() this shouldn't be called, but we deal with it anyway.
      Overrides:
        `evaluateItem` in class `UnparsedText`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### call

          public Sequence call(XPathContext context,
                      Sequence[] arguments)
                        throws XPathException

      Evaluate the expression
      Specified by:
        `call` in interface `Callable`
      Overrides:
        `call` in class `UnparsedText`
      Parameters:
        `context` - the dynamic evaluation context
        `arguments` - the values of the arguments, supplied as SequenceIterators
      Returns:
        the result of the evaluation, in the form of a SequenceIterator
      Throws:
        `XPathException` - if a dynamic error occurs during the evaluation of the expression

    - #### iterate

          public SequenceIterator iterate(XPathContext context)
                                   throws XPathException

      Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation handles iteration for expressions that return singleton values: for non-singleton expressions, the subclass must provide its own implementation.
      Overrides:
        `iterate` in class `Expression`
      Parameters:
        `context` - supplies the context for evaluation
      Returns:
        a SequenceIterator that can be used to iterate over the result of the expression
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### readFile

          public CharSequence readFile(String href,
                              String baseURI,
                              String encoding,
                              XPathContext context)
                                throws XPathException

      Supporting routine to load one external file given a URI (href) and a baseURI
      Overrides:
        `readFile` in class `UnparsedText`
      Throws:
        `XPathException`

    - #### getAbsoluteURI

          public static URI getAbsoluteURI(String href,
                           String baseURI)
                                    throws XPathException

      Throws:
        `XPathException`

    - #### handleIOError

          public static XPathException handleIOError(URI absoluteURI,
                                     IOException ioErr)

    - #### readFile

          public static CharSequence readFile(NameChecker checker,
                              Reader reader)
                                       throws IOException,
                                              XPathException

      Read the contents of an unparsed text file
      Parameters:
        `checker` - NameChecker for checking whether characters are valid XML characters
        `reader` - Reader to be used for reading the file
      Returns:
        a CharSequence representing the contents of the file
      Throws:
        `IOException` - if a failure occurs reading the file
        `XPathException` - if the file contains illegal characters

    - #### main

          public static void main(String[] args)
                           throws Exception

      Throws:
        `Exception`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.